#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <sys/wait.h>
#include <errno.h>

#include "global.h"

struct formule *names = NULL;

int add_tree (struct formule **tree, char *name)
{
	if (!*tree)
	{
		*tree = calloc(1,sizeof(struct formule));
		(*tree)->name = name;
		return 0;
	}
	int c = strcmp((*tree)->name,name);
	if (c < 0)
		return add_tree(&((*tree)->left),name);
	else if (c > 0)
		return add_tree(&((*tree)->right),name);
	else
		return 1;
}

void find_names (struct formule *f)
{
	switch (f->type)
	{
	    case F_VAR:
		if (add_tree(&names,f->name)) break;
		printf("(declare-const %s Bool)\n",f->name);
		break;
	    case F_AND:
	    case F_OR:
	    case F_IMP:
	    case F_EQV:
		find_names(f->left);
		find_names(f->right);
		break;
	    case F_NOT:
		find_names(f->left);
		break;
	}
}

#define binprint(x) printf("("); printf(x); output(f->left); output(f->right); printf(") ");

void output (struct formule *f)
{
	switch (f->type)
	{
	    case F_VAR:
		printf("%s ",f->name);
		break;
	    case F_AND:
		binprint("and "); break;
	    case F_OR:
		binprint("or "); break;
	    case F_IMP:
		binprint("=> "); break;
	    case F_EQV:
		binprint("= "); break;
	    case F_NOT:
		printf("(not ");
		output(f->left);
		printf(") ");
		break;
	}
}

int main (int argc, char **argv)
{
	struct formule *f = parser();
	find_names(f);
	printf("(assert ");
	output(f);
	printf(")\n(check-sat)\n(get-model)\n");
	return 0;
}
