%{

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "global.h"

struct formule* theformula;

int yylex();

void yyerror (char *info)
{ 
	fprintf(stderr,"cannot parse input: %s; discarded\n",info);
}

struct formule* construct(int type, struct formule *left, struct formule *right)
{
	struct formule *f = calloc(1,sizeof(struct formule));
	f->type = type;
	f->left = left;
	f->right = right;
	return f;
}

%}

%union 
{
	char *string;
	struct formule* f;
}

%type <f> form
%token <string> VAR
%token AND OR NOT EQV IMP

%left IMP EQV
%left OR
%left AND
%nonassoc NOT

%%

start	: form { theformula = $1; }

form    : form AND form { $$ = construct(F_AND,$1,$3); }
	| form OR form { $$ = construct(F_OR,$1,$3); }
	| form IMP form { $$ = construct(F_IMP,$1,$3); }
	| form EQV form { $$ = construct(F_EQV,$1,$3); }
	| NOT form { $$ = construct(F_NOT,$2,NULL); }
	| '(' form ')' { $$ = $2; }
	| VAR
	  {
		$$ = calloc(1,sizeof(struct formule));
		$$->type = F_VAR;
		$$->name = $1;
	  }

%%

#include "lex.c"

struct formule* parser (char *command)
{
	if (yyparse()) return NULL;
	return theformula;
}
